#include "Component.h"

#include "DataType.h"

#include <iostream>

namespace Databoard {
	namespace Type {

		Component::Component(std::string name, DataType* type)
		{
			usingBuiltInType = type->getNotBuiltIn();
			
			this->name = name;
			this->type = type;
		}

		Component::~Component()
		{
			if(type != NULL && usingBuiltInType == false)
			{
				delete type;
			}
		}

		std::string Component::getName()
		{
			return name;
		}

		DataType* Component::getDataBoard()
		{
			return type;
		}
	}
}
