#include "MapType.h"

namespace Databoard {
	namespace Type {

		MapType::MapType()
		{
			keyType = NULL;
			valueType = NULL;
		}

		MapType::MapType(DataType* keyType, DataType* valueType)
		{
			this->keyType = keyType;
			this->valueType = valueType;
		}

		MapType::~MapType()
		{
			if(keyType != NULL)
			{
				delete keyType;
			}

			if(valueType != NULL)
			{
				delete valueType;
			}
		}

		DataType* MapType::getKeyType()
		{
			return keyType;
		}

		DataType* MapType::getValueType()
		{
			return valueType;
		}

		void MapType::setKeyType(DataType* keyType)
		{
			this->keyType = keyType;
		}

		void MapType::setValueType(DataType* valueType)
		{
			this->valueType = valueType;
		}

		std::string MapType::writeOut(int /*indent*/)
		{
			std::string s;

			s.append("Map");

			s += "(";
			s += keyType->writeOut();
			s += ", ";
			s += valueType->writeOut();
			s += ")";

			return s;
		}
	}
}
