#include "OptionalType.h"

namespace Databoard {
	namespace Type {

		OptionalType::OptionalType()
		{
			componentType = NULL;
		}

		OptionalType::OptionalType(DataType* componentType)
		{
			this->componentType = componentType;
		}

		OptionalType::~OptionalType()
		{
			if(componentType != NULL)
			{
				delete componentType;
			}
		}

		DataType* OptionalType::getComponentType()
		{
			return componentType;
		}

		void OptionalType::setComponentType(DataType* componentType)
		{
			this->componentType = componentType;
		}

		std::string OptionalType::writeOut(int /*indent*/)
		{
			std::string s;

			s.append("Optional");

			s += "(";

			if(componentType != NULL)
			{
				s += componentType->writeOut();
			}

			s += ")";

			return s;
		}
	}
}
