/*******************************************************************************
 * Copyright (c) 2007 VTT Technical Research Centre of Finland and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.databoard.tests;

import java.io.File;

import org.simantics.databoard.Accessors;
import org.simantics.databoard.Bindings;
import org.simantics.databoard.Datatypes;
import org.simantics.databoard.accessor.file.FileAccessor;
import org.simantics.databoard.accessor.file.FileVariantAccessor;
import org.simantics.databoard.type.Datatype;

public class Jotakin14 {

	public static void main(String[] args) throws Exception {
		// Test if accessor leaves open handles
		File file = File.createTempFile("delete-me-", ".tmp");
		Datatype type = Datatypes.STRING;
		file.delete();
		
		for (int i=0; i<100000; i++) {
			FileAccessor a = Accessors.createFile(file, type);
			a.setValue(Bindings.STRING, "Moi");
			a.close();
			
			FileVariantAccessor va = Accessors.openAccessor(file);
			a = va.getContentAccessor();
			System.out.println(i+": "+a.getValue(Bindings.STRING));
			a.close();
		}
		file.delete();
	}
	
}

