package org.simantics.databoard.annotations;

import java.lang.annotation.Annotation;
import java.lang.reflect.Array;

public class ArgumentImpl implements Arguments {

	Class<?>[] args;
	
	public ArgumentImpl(Class<?>...args) {
		this.args = args;
	}

	
	/**
	 * Drop first arguments from an argument list. 
	 * If all were dropped, null is returned.
	 *
	 * @param src source argument or null
	 * @param count argument count
	 * @return Argument or null.
	 */
	public static Arguments dropArguments(Arguments src, int count) {
		if (src==null) return null;
		int newLen = src.value().length - count;
		if (newLen<=0) return null;
		Class<?>[] newList = (Class<?>[]) Array.newInstance(Class.class, newLen);
		System.arraycopy(src.value(), count, newList, 0, newLen);
		return new ArgumentImpl(newList);
	}	
	
	@Override
	public Class<? extends Annotation> annotationType() {
		return Arguments.class;
	}

	@Override
	public Class<?>[] value() {
		return args;
	}

}
